(define (domain machinery)
     (:requirements :typing
                    :durative-actions
                    :duration-inequalities
                    :negative-preconditions)
     (:types machine)
     (:predicates
          (free ?m - machine)
          (required ?m - machine)
          (init-done)
          (start-done)
          (j1-done)
          (j2-done)
          (j3-done)
          (j4-done)
          (done)
     )

     (:uncontrollable-durative-action working
          :parameters (?m - machine)
          :duration (and (<= ?duration 12) (>= ?duration 10))
          :condition (at start (required ?m))
          :effect (and (at start (not (required ?m))) (at end (free ?m)))
     )


     (:durative-action do_start
          :parameters (?m - machine)
          :duration (>= ?duration 1)
          :condition (at start (init-done))
          :effect (at end (start-done)))


     (:durative-action j1
          :parameters (?m - machine)
          :duration (>= ?duration 1)
          :condition (and (at start (start-done))
                          (at start (free ?m))
                          (at end (free ?m)))
          :effect (and (at start (not (free ?m)))
                       (at start (required ?m))
                       (at end (not (required ?m)))
                       (at end (j1-done))))

     (:durative-action j2
          :parameters (?m - machine)
          :duration (>= ?duration 1)
          :condition (and (at start (j1-done))
                          (at start (free ?m))
                          (at end (free ?m)))
          :effect (and (at start (not (free ?m)))
                       (at start (required ?m))
                       (at end (not (required ?m)))
                       (at end (j2-done))))

     (:durative-action j3
          :parameters (?m - machine)
          :duration (>= ?duration 1)
          :condition (and (at start (j2-done))
                          (at start (free ?m))
                          (at end (free ?m)))
          :effect (and (at start (not (free ?m)))
                       (at start (required ?m))
                       (at end (not (required ?m)))
                       (at end (j3-done))))

     (:durative-action j4
          :parameters (?m - machine)
          :duration (>= ?duration 1)
          :condition (and (at start (j3-done))
                          (at start (free ?m))
                          (at end (free ?m)))
          :effect (and (at start (not (free ?m)))
                       (at start (required ?m))
                       (at end (not (required ?m)))
                       (at end (j4-done))))



     (:durative-action finish
          :parameters (?m - machine)
          :duration (>= ?duration 1)
          :condition (and (at start (not (required ?m))) (at start (j4-done)))
          :effect (at end (done)))

)
